import copy         # Fuer das Kopieren von Arrays
import field        # Spielbrettverwaltung
import gridsearch   # Mustererkennung auf dem Spielbrett
import random       # Zufallsgenerator


# Eine einfache KI, die versucht, die groebsten Fehler zu vermeiden, aber insgesamt sehr naiv spielt.
# Um die Logik nachvollziehbar zu zeigen, werden bestimmte Zuege kommentiert. 
def prompt_move(board, me, length):
    # Me = 1 -> You = 2, Me = 2 -> You = 1.
    you = me % 2 + 1
    
    # Finde die aktuell erreichbaren Positionen (wo der Stein hinfaellt) und markiere sie mit 3
    moves = field.legal_moves(board)
    marker = copy.deepcopy(board)
    for col in moves:
        marker[field.ground(board, col)][col] = 3
    
    # Finde das Muster [3 ICH ICH ICH], dass mich gewinnen laesst.
    combo = gridsearch.find_combo(marker, [3] + [me] * (length - 1), 0)
    if combo >= 0:
        print "Computer: \"Jetzt gewinne ich!\""
        return combo

    # Finde das Muster [ICH 3 ICH ICH], dass mich gewinnen laesst.
    combo = gridsearch.find_combo(marker, [me] + [3] + [me] * (length - 2), 1)
    if combo >= 0:
        print "Computer: \"Jetzt gewinne ich!\""
        return combo

    # Finde das Muster [3 DU DU DU], dass mich vor deinem Sieg warnt.
    combo = gridsearch.find_combo(marker, [3] + [you] * (length - 1), 0) 
    if combo >= 0:
        print "Computer: \"Das war ja haarscharf.\""
        return combo

    # Finde das Muster [DU 3 DU DU], dass mich gewinnen laesst.
    combo = gridsearch.find_combo(marker, [you] + [3] + [you] * (length - 2), 1)
    if combo >= 0:
        print "Computer: \"Das war ja haarscharf.\""
        return combo

    # Merke: Bei mehr als Vier Steinen in der Gewinnreihe muessen noch viele weiter Faelle behandelt werden,
    # die hier eingespart werden.

    # Etwas komplexer: Finde das Muster [3 ICH ICH 3 3], dass uns eine "Doppelmuehle" ermoeglicht.
    # ( 3 ICH ICH ICH 3, ein unvermeidlicher Gewinn).
    combo = gridsearch.find_combo(marker, [3] + [me] * (length - 2) + [3, 3], 3)
    if combo >= 0:
        print "Computer: \"Jetzt sitzt du in der Klemme.\""
        return combo

    # Erkenne dasselbe Muster beim Gegner, um seinen Sieg zu vereiteln. [3 DU DU 3 3]
    combo = gridsearch.find_combo(marker, [3] + [you] * (length - 2) + [3, 3], 3)
    if combo >= 0:
        print "Computer: \"Ich sehe eine Falle kommen.\""
        return combo

    # Viele weitere Gefahren oder Gelegenheiten werden nicht gesucht - z.B.
    #    ?
    #    ?X
    #    X X
    #    X  X
    #    X
    # Wo X entweder den "Turm" oder die "Leiter" vollenden kann, oder andere zwei-dimensionale Muster.
    

    # Spiele zufaellig.
    print "Computer: \"Ich spiele einfach mal irgendetwas.\""
    # Merke: Ohne Aufruf von random.seed() wird laut Python-Docs die Systemzeit oder urandom als Seed verwendet.
    return random.choice(moves)


        
