import gridsearch     # Mustererkennung auf dem Spielbrett, um Gewinner zu finden.

# Verwaltung und Pruefung des Spielfelds

# Initialisiert das Spielfeld
def init_field(width, height):
    # Achtung: [[0]*x]*y ist unmoeglich, da lediglich pointer kopiert werden.
    # Lege stattdessen die Zeilen so an:
    field = [[]] * height
    for y in range(0, height):
        field[y] = [0] * width
    return field

# Hat ein Spieler das Spiel gewonnen?
def is_won(board, length, player):
    if gridsearch.find_combo(board, [player] * length, 0) >= 0:
        return 1

# Wirft einen Spielstein in den Schacht. Gibt die Reihe zurueck,
# in der der Stein landet.
def insert_move(field, column, player):
    # Bestimme das unterste freie Feld in der gewuenschten Spalte:
    for y in range(len(field), 0, -1):
        if field[y-1][column] == 0:
            field[y-1][column] = player
            return y-1

# Bestimme, welche Reihen noch frei sind. Wird von 0 indiziert
def legal_moves(field):
    legal = range(0, len(field[0]))
    # Schau die oberste Reihe an (setze ein gueltiges Feld voraus):
    for i, cell in enumerate(field[0]):
        if cell > 0:
            # Loesche den Wert, nicht den Index - der verschiebt sich naemlich.
            legal.remove(i)
    return legal

# Bestimme den "Boden" der Spalte, d.H. die unterste freie Position.
def ground(field, x):
    for y, row in enumerate(field):
        if row[x] > 0:
            return y - 1
    return len(field) - 1
